/** 
 *   test_ib: IAR Bus (IPC) - Testing and demo implementation (server
 *   side).
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 **/

#include <stdio.h>
#include <unistd.h>

#include "my_stdio.h"
#include "socket_client.h"
#include "iar_bus.h"


#define TEST_IP "127.0.0.1"
#define TEST_PORT 1100


int impares(void)
{
	IBFD *dc;
	int ret;
	uint32_t data;
	IB_PK d;
	int addr;
	
	dc = ibus_client_connect(TEST_IP, TEST_PORT);
	//dc = ibus_client_connect_local("test");
	addr = ibus_set_addr(dc, 0x5);
	printf("Odd addr: 0x%x\n", addr);
	ibus_bcast_on( dc );

	//data = (uint32_t *) IB_PK_DATA(&d);
	__builtin_memcpy(&data, IB_PK_DATA(&d), sizeof(uint32_t));
	do {
		ret = ibus_read(dc, &d);
		if( ret && IB_PK_SIZE(&d) > 0 ) {
			if( data & 0x1 ){
				data++; 
				ibus_send_data( dc, &data, sizeof(uint32_t));
			}				
		}
	} while(ret > 0);

	return 0;
}


int pares(void)
{

	IBFD *dc;
	int ret = 1;
	int data;
	IB_PK d;
	int addr;

	dc = ibus_client_connect(TEST_IP, TEST_PORT);
	//fd = call_socket_local("test");
	addr = ibus_set_addr(dc, 0x4);
	printf("Even addr: 0x%x\n", addr);
	ibus_bcast_on( dc );

	while(ret > 0){
		ret = sock_read(IBFD_GET(dc), &d, 
				sizeof(struct ib_packet_head) );
		if( IB_PK_SIZE(&d) > 0) {
			ret = sock_read(IBFD_GET(dc), &data, sizeof(int) );
			if( !(data & 0x1) ){
				data++;
				//ibus_send_data_to( dc, 0x5, &data, sizeof(int));
				ibus_send_data( dc, &data, sizeof(int));
			}				
		}
	}

	return 0;
}

int wait_for( int num)
{
	IBFD *dc;
	int ret = 1;
	int data;
	struct ib_packet d;

	dc = ibus_client_connect(TEST_IP, TEST_PORT);
	//dc = ibus_client_connect_local("test");
	ibus_bcast_on( dc );

	while(ret > 0){
		ret = sock_read(IBFD_GET(dc), &d, sizeof(struct ib_packet_head));
		if( d.h.size > 0) {
			ret = sock_read(IBFD_GET(dc), &data, sizeof(int) );
			if( data == num ){
				data++;
				ibus_send_data( dc, &data, sizeof(int));
			}				
		}
	}

	return 0;
}


int main(int argc, const char *argv[]) 
{
	int pid;
	//int i;

	//SET_VERBOSE_FLAG(PINFO);
	if ( (pid=fork()) == 0 ) {
		printf("Starting IB core...\n");
		//iar_bus_start("test");
		iar_bus_inet_start(TEST_PORT);
	}
	sleep(1);
	
	if ( (pid=fork()) == 0 ) {
		pares();
	}
	impares();
	/*
	  for(i=1;i<512;i++){
	  if ( (pid=fork()) == 0 ) {
	  wait_for( i );
	  }
	  }
	  wait_for( i );
	*/

	return 0;
}


